OpenMM

- Main Page
- Related Pages
- Classes

- Class List
- Class Hierarchy
- Class Members

All Classes Namespaces Functions Variables Pages
Public Member Functions | Public Attributes | List of all members
CustomTorsionForce Class Reference

This class implements interactions between sets of four particles that depend on the torsion angle between them. More...

Inheritance diagram for CustomTorsionForce:

## Public Member Functions
def | getNumTorsions
| getNumTorsions(CustomTorsionForce self) -> int More...
def | getNumPerTorsionParameters
| getNumPerTorsionParameters(CustomTorsionForce self) -> int More...
def | getNumGlobalParameters
| getNumGlobalParameters(CustomTorsionForce self) -> int More...
def | getEnergyFunction
| getEnergyFunction(CustomTorsionForce self) -> std::string const & More...
def | setEnergyFunction
| setEnergyFunction(CustomTorsionForce self, std::string const & energy) More...
def | addPerTorsionParameter
| addPerTorsionParameter(CustomTorsionForce self, std::string const & name) -> int More...
def | getPerTorsionParameterName
| getPerTorsionParameterName(CustomTorsionForce self, int index) -> std::string const & More...
def | setPerTorsionParameterName
| setPerTorsionParameterName(CustomTorsionForce self, int index, std::string const & name) More...
def | addGlobalParameter
| addGlobalParameter(CustomTorsionForce self, std::string const & name, double defaultValue) -> int More...
def | getGlobalParameterName
| getGlobalParameterName(CustomTorsionForce self, int index) -> std::string const & More...
def | setGlobalParameterName
| setGlobalParameterName(CustomTorsionForce self, int index, std::string const & name) More...
def | getGlobalParameterDefaultValue
| getGlobalParameterDefaultValue(CustomTorsionForce self, int index) -> double More...
def | setGlobalParameterDefaultValue
| setGlobalParameterDefaultValue(CustomTorsionForce self, int index, double defaultValue) More...
def | addTorsion
| addTorsion(CustomTorsionForce self, int particle1, int particle2, int particle3, int particle4, vectord parameters) -> int More...
def | getTorsionParameters
| getTorsionParameters(CustomTorsionForce self, int index) More...
def | setTorsionParameters
| setTorsionParameters(CustomTorsionForce self, int index, int particle1, int particle2, int particle3, int particle4, vectord parameters) More...
def | updateParametersInContext
| updateParametersInContext(CustomTorsionForce self, Context context) More...
def | usesPeriodicBoundaryConditions
| usesPeriodicBoundaryConditions(CustomTorsionForce self) -> bool More...
def | __init__
| init(OpenMM::CustomTorsionForce self, std::string const & energy) -> CustomTorsionForce init(OpenMM::CustomTorsionForce self, CustomTorsionForce other) -> CustomTorsionForce More...
def | __del__
| del(OpenMM::CustomTorsionForce self) More...
Public Member Functions inherited from Force
def | __init__
def | __del__
| del(OpenMM::Force self) More...
def | getForceGroup
| getForceGroup(Force self) -> int More...
def | setForceGroup
| setForceGroup(Force self, int group) More...
def | usesPeriodicBoundaryConditions
| usesPeriodicBoundaryConditions(Force self) -> bool More...
def | __copy__
def | __deepcopy__

## Public Attributes
| this

## Detailed Description

This class implements interactions between sets of four particles that depend on the torsion angle between them.

Unlike PeriodicTorsionForce, the functional form of the interaction is completely customizable, and may involve arbitrary algebraic expressions. In addition to the angle formed by the particles, it may depend on arbitrary global and per-torsion parameters.

To use this class, create a CustomTorsionForce object, passing an algebraic expression to the constructor that defines the interaction energy between each set of particles. The expression may depend on theta, the torsion angle formed by the particles, as well as on any parameters you choose. Then call addPerTorsionParameter() to define per-torsion parameters, and addGlobalParameter() to define global parameters. The values of per-torsion parameters are specified as part of the system definition, while values of global parameters may be modified during a simulation by calling Context::setParameter(). Finally, call addTorsion() once for each torsion. After an torsion has been added, you can modify its parameters by calling setTorsionParameters(). This will have no effect on Contexts that already exist unless you call updateParametersInContext().

As an example, the following code creates a CustomTorsionForce that implements a harmonic potential:

`CustomTorsionForce* force = new CustomTorsionForce("0.5*k*(theta-theta0)^2");`

This force depends on two parameters: the spring constant k and equilibrium angle theta0. The following code defines these parameters:

``

    force->addPerTorsionParameter("k");
    force->addPerTorsionParameter("theta0");

Expressions may involve the operators + (add), - (subtract), * (multiply), / (divide), and ^ (power), and the following functions: sqrt, exp, log, sin, cos, sec, csc, tan, cot, asin, acos, atan, sinh, cosh, tanh, erf, erfc, min, max, abs, floor, ceil, step, delta, select. All trigonometric functions are defined in radians, and log is the natural logarithm. step(x) = 0 if x is less than 0, 1 otherwise. delta(x) = 1 if x is 0, 0 otherwise. select(x,y,z) = z if x = 0, y otherwise.

## Constructor & Destructor Documentation

def __init__ | ( |  | self,
|  |  | args
| ) |  |

init(OpenMM::CustomTorsionForce self, std::string const & energy) -> CustomTorsionForce init(OpenMM::CustomTorsionForce self, CustomTorsionForce other) -> CustomTorsionForce

Create a CustomTorsionForce.

Parameters

  energy | an algebraic expression giving the interaction energy between three particles as a function of theta, the torsion angle between them

References simtk.openmm.openmm.stripUnits().

def __del__ | ( |  | self | ) |

del(OpenMM::CustomTorsionForce self)

References simtk.openmm.openmm.stripUnits().

## Member Function Documentation

def addGlobalParameter | ( |  | self,
|  |  | args
| ) |  |

addGlobalParameter(CustomTorsionForce self, std::string const & name, double defaultValue) -> int

Add a new global parameter that the interaction may depend on.

Parameters

  name | the name of the parameter
  defaultValue | the default value of the parameter

References simtk.openmm.openmm.stripUnits().

def addPerTorsionParameter | ( |  | self,
|  |  | args
| ) |  |

addPerTorsionParameter(CustomTorsionForce self, std::string const & name) -> int

Add a new per-torsion parameter that the interaction may depend on.

Parameters

  name | the name of the parameter

References simtk.openmm.openmm.stripUnits().

def addTorsion | ( |  | self,
|  |  | args
| ) |  |

addTorsion(CustomTorsionForce self, int particle1, int particle2, int particle3, int particle4, vectord parameters) -> int

Add a torsion term to the force field.

Parameters

  particle1 | the index of the first particle connected by the torsion
  particle2 | the index of the second particle connected by the torsion
  particle3 | the index of the third particle connected by the torsion
  particle4 | the index of the fourth particle connected by the torsion
  parameters | the list of parameters for the new torsion

References simtk.openmm.openmm.stripUnits().

def getEnergyFunction | ( |  | self,
|  |  | args
| ) |  |

getEnergyFunction(CustomTorsionForce self) -> std::string const &

Get the algebraic expression that gives the interaction energy for each torsion

References simtk.openmm.openmm.stripUnits().

def getGlobalParameterDefaultValue | ( |  | self,
|  |  | args
| ) |  |

getGlobalParameterDefaultValue(CustomTorsionForce self, int index) -> double

Get the default value of a global parameter.

Parameters

  index | the index of the parameter for which to get the default value

References simtk.openmm.openmm.stripUnits().

def getGlobalParameterName | ( |  | self,
|  |  | args
| ) |  |

getGlobalParameterName(CustomTorsionForce self, int index) -> std::string const &

Get the name of a global parameter.

Parameters

  index | the index of the parameter for which to get the name

References simtk.openmm.openmm.stripUnits().

def getNumGlobalParameters | ( |  | self,
|  |  | args
| ) |  |

getNumGlobalParameters(CustomTorsionForce self) -> int

Get the number of global parameters that the interaction depends on.

References simtk.openmm.openmm.stripUnits().

def getNumPerTorsionParameters | ( |  | self,
|  |  | args
| ) |  |

getNumPerTorsionParameters(CustomTorsionForce self) -> int

Get the number of per-torsion parameters that the interaction depends on.

References simtk.openmm.openmm.stripUnits().

def getNumTorsions | ( |  | self,
|  |  | args
| ) |  |

getNumTorsions(CustomTorsionForce self) -> int

Get the number of torsions for which force field parameters have been defined.

References simtk.openmm.openmm.stripUnits().

def getPerTorsionParameterName | ( |  | self,
|  |  | args
| ) |  |

getPerTorsionParameterName(CustomTorsionForce self, int index) -> std::string const &

Get the name of a per-torsion parameter.

Parameters

  index | the index of the parameter for which to get the name

References simtk.openmm.openmm.stripUnits().

def getTorsionParameters | ( |  | self,
|  |  | args
| ) |  |

getTorsionParameters(CustomTorsionForce self, int index)

Get the force field parameters for a torsion term.

Parameters

  index | the index of the torsion for which to get parameters
  particle1 | the index of the first particle connected by the torsion
  particle2 | the index of the second particle connected by the torsion
  particle3 | the index of the third particle connected by the torsion
  particle4 | the index of the fourth particle connected by the torsion
  parameters | the list of parameters for the torsion

References simtk.openmm.openmm.stripUnits().

def setEnergyFunction | ( |  | self,
|  |  | args
| ) |  |

setEnergyFunction(CustomTorsionForce self, std::string const & energy)

Set the algebraic expression that gives the interaction energy for each torsion

References simtk.openmm.openmm.stripUnits().

def setGlobalParameterDefaultValue | ( |  | self,
|  |  | args
| ) |  |

setGlobalParameterDefaultValue(CustomTorsionForce self, int index, double defaultValue)

Set the default value of a global parameter.

Parameters

  index | the index of the parameter for which to set the default value
  name | the default value of the parameter

References simtk.openmm.openmm.stripUnits().

def setGlobalParameterName | ( |  | self,
|  |  | args
| ) |  |

setGlobalParameterName(CustomTorsionForce self, int index, std::string const & name)

Set the name of a global parameter.

Parameters

  index | the index of the parameter for which to set the name
  name | the name of the parameter

References simtk.openmm.openmm.stripUnits().

def setPerTorsionParameterName | ( |  | self,
|  |  | args
| ) |  |

setPerTorsionParameterName(CustomTorsionForce self, int index, std::string const & name)

Set the name of a per-torsion parameter.

Parameters

  index | the index of the parameter for which to set the name
  name | the name of the parameter

References simtk.openmm.openmm.stripUnits().

def setTorsionParameters | ( |  | self,
|  |  | args
| ) |  |

setTorsionParameters(CustomTorsionForce self, int index, int particle1, int particle2, int particle3, int particle4, vectord parameters)

Set the force field parameters for a torsion term.

Parameters

  index | the index of the torsion for which to set parameters
  particle1 | the index of the first particle connected by the torsion
  particle2 | the index of the second particle connected by the torsion
  particle3 | the index of the third particle connected by the torsion
  particle4 | the index of the fourth particle connected by the torsion
  parameters | the list of parameters for the torsion

References simtk.openmm.openmm.stripUnits().

def updateParametersInContext | ( |  | self,
|  |  | args
| ) |  |

updateParametersInContext(CustomTorsionForce self, Context context)

Update the per-torsion parameters in a Context to match those stored in this Force object. This method provides an efficient method to update certain parameters in an existing Context without needing to reinitialize it. Simply call setTorsionParameters() to modify this object's parameters, then call updateParametersInContext() to copy them over to the Context.

This method has several limitations. The only information it updates is the values of per-torsion parameters. All other aspects of the Force (such as the energy function) are unaffected and can only be changed by reinitializing the Context. The set of particles involved in a torsion cannot be changed, nor can new torsions be added.

References simtk.openmm.openmm.stripUnits().

def usesPeriodicBoundaryConditions | ( |  | self,
|  |  | args
| ) |  |

usesPeriodicBoundaryConditions(CustomTorsionForce self) -> bool

Returns whether or not this force makes use of periodic boundary conditions.

References simtk.openmm.openmm.stripUnits().

## Member Data Documentation

this

Referenced by System.__init__().

The documentation for this class was generated from the following file:

- openmm.py